package extensions;

import java.io.*;
import java.net.*;
import java.util.*;
import java.util.regex.Pattern;

import dareka.common.Logger;
import dareka.extensions.*;
import dareka.processor.*;
import dareka.processor.impl.Cache;

/**
 * @author ListX
 */
public class nlGetFileExt implements Extension, Processor  {
	//version
	public String getVersionString(){
		return "nlGetFileExt rev01";
	}
	// Extension interface
	public Object queryInterface(Extension.Type type) {
		if (type == Extension.Type.Extension1)
			return (Extension) this;
		if (type == Extension.Type.Processor1)
			return (Processor) this;
		return null;
	}
	// HTTP̃\bh
	public String[] getSupportedMethods() {
		return new String[] { "GET" };
	}
	// URL̐K\
	public Pattern getSupportedURLAsPattern() {
		return Pattern.compile("^http://www\\.nicovideo\\.jp/cache/extlist$");
	}
	public String getSupportedURLAsString() {
		return null;
	}
	// Y郊NGXg̍ۂɌĂ΂
	public Resource onRequest(HttpRequestHeader requestHeader, Socket browser)
			throws IOException {
		
		Map<String, File> caches = Cache.getId2File();
		String[] idList = caches.keySet().toArray(new String[0]);
		Arrays.sort(idList);
		
		StringBuffer sb = new StringBuffer("extList={\n");
		for (String id: idList){
			sb.append('"'+id+'"'+":\""+caches.get(id).getName().replaceFirst(".*\\.(.+?)","$1")+"\",\n");
		}
		
		String content = new String(sb).replaceFirst(",\n$","\n};");
		StringResource r = new StringResource(content);
		r.setResponseHeader("Content-Type", "text/plain");
		Logger.info("nlGetFileExt rev01: return extList");
		return r;
	}
}